require 'rest-client'
require 'nokogiri'



## CURRENT ISSUE: 502 BAD GATEWAY WHEN TESTING GET_ADVISORY_URLS METHOD. 
## TODO: COPY THE EXACT HEADERS THAT YOU ARE GIVING FROM THE WEB BROWSER
## AND SEND THEM WITH THIS REQUEST AND TEST AGAIN.
class MozillaSecurityAdvisoryScraper
  attr_accessor :index_url
  def initialize()
    @index_url = "https://www.mozilla.org/en-US/security/advisories"
  end

  def get_index
    headers = { 
      :accept => 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
      :user_agent => 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:105.0) Gecko/20100101 Firefox/105.0'
    }
    response = RestClient::Request.execute(
      :method => :get,
      :url => index_url,
      :headers => headers
    )
    if response.code == 200
      response.body
    else
      puts "HTTP Status code: #{r.code}"
    end
  end

  def parse_index(response_body)
    Nokogiri::HTML(response_body)
  end

  def advisory_urls(html_doc)
    html_doc.xpath('//li[@class="level-item"]/a').map {|link| relative_url = link['href']; "https://www.mozilla.org#{relative_url}"}
  end

  def get_advisory_urls
    body = get_index
    doc = parse_index(body)
    advisory_urls(doc)
  end
end
